// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_mapem_ts_msgs:msg/DataParameters.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__DATA_PARAMETERS__TRAITS_HPP_
#define ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__DATA_PARAMETERS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_mapem_ts_msgs/msg/detail/data_parameters__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace etsi_its_mapem_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const DataParameters & msg,
  std::ostream & out)
{
  out << "{";
  // member: process_method
  {
    out << "process_method: ";
    rosidl_generator_traits::value_to_yaml(msg.process_method, out);
    out << ", ";
  }

  // member: process_method_is_present
  {
    out << "process_method_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.process_method_is_present, out);
    out << ", ";
  }

  // member: process_agency
  {
    out << "process_agency: ";
    rosidl_generator_traits::value_to_yaml(msg.process_agency, out);
    out << ", ";
  }

  // member: process_agency_is_present
  {
    out << "process_agency_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.process_agency_is_present, out);
    out << ", ";
  }

  // member: last_checked_date
  {
    out << "last_checked_date: ";
    rosidl_generator_traits::value_to_yaml(msg.last_checked_date, out);
    out << ", ";
  }

  // member: last_checked_date_is_present
  {
    out << "last_checked_date_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.last_checked_date_is_present, out);
    out << ", ";
  }

  // member: geoid_used
  {
    out << "geoid_used: ";
    rosidl_generator_traits::value_to_yaml(msg.geoid_used, out);
    out << ", ";
  }

  // member: geoid_used_is_present
  {
    out << "geoid_used_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.geoid_used_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const DataParameters & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: process_method
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "process_method: ";
    rosidl_generator_traits::value_to_yaml(msg.process_method, out);
    out << "\n";
  }

  // member: process_method_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "process_method_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.process_method_is_present, out);
    out << "\n";
  }

  // member: process_agency
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "process_agency: ";
    rosidl_generator_traits::value_to_yaml(msg.process_agency, out);
    out << "\n";
  }

  // member: process_agency_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "process_agency_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.process_agency_is_present, out);
    out << "\n";
  }

  // member: last_checked_date
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "last_checked_date: ";
    rosidl_generator_traits::value_to_yaml(msg.last_checked_date, out);
    out << "\n";
  }

  // member: last_checked_date_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "last_checked_date_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.last_checked_date_is_present, out);
    out << "\n";
  }

  // member: geoid_used
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "geoid_used: ";
    rosidl_generator_traits::value_to_yaml(msg.geoid_used, out);
    out << "\n";
  }

  // member: geoid_used_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "geoid_used_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.geoid_used_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const DataParameters & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_mapem_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_mapem_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_mapem_ts_msgs::msg::DataParameters & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_mapem_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_mapem_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_mapem_ts_msgs::msg::DataParameters & msg)
{
  return etsi_its_mapem_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_mapem_ts_msgs::msg::DataParameters>()
{
  return "etsi_its_mapem_ts_msgs::msg::DataParameters";
}

template<>
inline const char * name<etsi_its_mapem_ts_msgs::msg::DataParameters>()
{
  return "etsi_its_mapem_ts_msgs/msg/DataParameters";
}

template<>
struct has_fixed_size<etsi_its_mapem_ts_msgs::msg::DataParameters>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<etsi_its_mapem_ts_msgs::msg::DataParameters>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<etsi_its_mapem_ts_msgs::msg::DataParameters>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__DATA_PARAMETERS__TRAITS_HPP_
