// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_mapem_ts_msgs:msg/SpeedLimitType.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__SPEED_LIMIT_TYPE__STRUCT_H_
#define ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__SPEED_LIMIT_TYPE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'UNKNOWN'.
enum
{
  etsi_its_mapem_ts_msgs__msg__SpeedLimitType__UNKNOWN = 0
};

/// Constant 'MAX_SPEED_IN_SCHOOL_ZONE'.
enum
{
  etsi_its_mapem_ts_msgs__msg__SpeedLimitType__MAX_SPEED_IN_SCHOOL_ZONE = 1
};

/// Constant 'MAX_SPEED_IN_SCHOOL_ZONE_WHEN_CHILDREN_ARE_PRESENT'.
enum
{
  etsi_its_mapem_ts_msgs__msg__SpeedLimitType__MAX_SPEED_IN_SCHOOL_ZONE_WHEN_CHILDREN_ARE_PRESENT = 2
};

/// Constant 'MAX_SPEED_IN_CONSTRUCTION_ZONE'.
enum
{
  etsi_its_mapem_ts_msgs__msg__SpeedLimitType__MAX_SPEED_IN_CONSTRUCTION_ZONE = 3
};

/// Constant 'VEHICLE_MIN_SPEED'.
enum
{
  etsi_its_mapem_ts_msgs__msg__SpeedLimitType__VEHICLE_MIN_SPEED = 4
};

/// Constant 'VEHICLE_MAX_SPEED'.
enum
{
  etsi_its_mapem_ts_msgs__msg__SpeedLimitType__VEHICLE_MAX_SPEED = 5
};

/// Constant 'VEHICLE_NIGHT_MAX_SPEED'.
enum
{
  etsi_its_mapem_ts_msgs__msg__SpeedLimitType__VEHICLE_NIGHT_MAX_SPEED = 6
};

/// Constant 'TRUCK_MIN_SPEED'.
enum
{
  etsi_its_mapem_ts_msgs__msg__SpeedLimitType__TRUCK_MIN_SPEED = 7
};

/// Constant 'TRUCK_MAX_SPEED'.
enum
{
  etsi_its_mapem_ts_msgs__msg__SpeedLimitType__TRUCK_MAX_SPEED = 8
};

/// Constant 'TRUCK_NIGHT_MAX_SPEED'.
enum
{
  etsi_its_mapem_ts_msgs__msg__SpeedLimitType__TRUCK_NIGHT_MAX_SPEED = 9
};

/// Constant 'VEHICLES_WITH_TRAILERS_MIN_SPEED'.
enum
{
  etsi_its_mapem_ts_msgs__msg__SpeedLimitType__VEHICLES_WITH_TRAILERS_MIN_SPEED = 10
};

/// Constant 'VEHICLES_WITH_TRAILERS_MAX_SPEED'.
enum
{
  etsi_its_mapem_ts_msgs__msg__SpeedLimitType__VEHICLES_WITH_TRAILERS_MAX_SPEED = 11
};

/// Constant 'VEHICLES_WITH_TRAILERS_NIGHT_MAX_SPEED'.
enum
{
  etsi_its_mapem_ts_msgs__msg__SpeedLimitType__VEHICLES_WITH_TRAILERS_NIGHT_MAX_SPEED = 12
};

/// Struct defined in msg/SpeedLimitType in the package etsi_its_mapem_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_mapem_ts_msgs__msg__SpeedLimitType
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/is_ts103301/MAPEM-PDU-Descriptions.asn
  ///   asn1/raw/is_ts103301/cdd/ITS-Container.asn
  ///   asn1/raw/is_ts103301/iso-patched/ISO24534-3_ElectronicRegistrationIdentificationVehicleDataModule-patched.asn
  ///   asn1/raw/is_ts103301/build/asn1/ISO-TS-19091-addgrp-C-2018-patched.asn
  ///   asn1/patched/is_ts103301/build/asn1/ISO14816_AVIAEINumberingAndDataStructures.asn
  ///   -t
  ///   mapem_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_mapem_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// SpeedLimitType ::= ENUMERATED {
  ///    unknown,
  ///    maxSpeedInSchoolZone,
  ///    maxSpeedInSchoolZoneWhenChildrenArePresent,
  ///    maxSpeedInConstructionZone,
  ///    vehicleMinSpeed,
  ///    vehicleMaxSpeed,
  ///    vehicleNightMaxSpeed,
  ///    truckMinSpeed,
  ///    truckMaxSpeed,
  ///    truckNightMaxSpeed,
  ///    vehiclesWithTrailersMinSpeed,
  ///    vehiclesWithTrailersMaxSpeed,
  ///    vehiclesWithTrailersNightMaxSpeed,
  ///    ...
  /// }
  /// ------------------------------------------------------------------------------
  uint8_t value;
} etsi_its_mapem_ts_msgs__msg__SpeedLimitType;

// Struct for a sequence of etsi_its_mapem_ts_msgs__msg__SpeedLimitType.
typedef struct etsi_its_mapem_ts_msgs__msg__SpeedLimitType__Sequence
{
  etsi_its_mapem_ts_msgs__msg__SpeedLimitType * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_mapem_ts_msgs__msg__SpeedLimitType__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__SPEED_LIMIT_TYPE__STRUCT_H_
