// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_mapem_ts_msgs:msg/Position3D.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__POSITION3_D__TRAITS_HPP_
#define ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__POSITION3_D__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_mapem_ts_msgs/msg/detail/position3_d__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'lat'
#include "etsi_its_mapem_ts_msgs/msg/detail/latitude__traits.hpp"
// Member 'lon'
#include "etsi_its_mapem_ts_msgs/msg/detail/longitude__traits.hpp"
// Member 'elevation'
#include "etsi_its_mapem_ts_msgs/msg/detail/elevation__traits.hpp"

namespace etsi_its_mapem_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Position3D & msg,
  std::ostream & out)
{
  out << "{";
  // member: lat
  {
    out << "lat: ";
    to_flow_style_yaml(msg.lat, out);
    out << ", ";
  }

  // member: lon
  {
    out << "lon: ";
    to_flow_style_yaml(msg.lon, out);
    out << ", ";
  }

  // member: elevation
  {
    out << "elevation: ";
    to_flow_style_yaml(msg.elevation, out);
    out << ", ";
  }

  // member: elevation_is_present
  {
    out << "elevation_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.elevation_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Position3D & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: lat
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "lat:\n";
    to_block_style_yaml(msg.lat, out, indentation + 2);
  }

  // member: lon
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "lon:\n";
    to_block_style_yaml(msg.lon, out, indentation + 2);
  }

  // member: elevation
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "elevation:\n";
    to_block_style_yaml(msg.elevation, out, indentation + 2);
  }

  // member: elevation_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "elevation_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.elevation_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Position3D & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_mapem_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_mapem_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_mapem_ts_msgs::msg::Position3D & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_mapem_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_mapem_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_mapem_ts_msgs::msg::Position3D & msg)
{
  return etsi_its_mapem_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_mapem_ts_msgs::msg::Position3D>()
{
  return "etsi_its_mapem_ts_msgs::msg::Position3D";
}

template<>
inline const char * name<etsi_its_mapem_ts_msgs::msg::Position3D>()
{
  return "etsi_its_mapem_ts_msgs/msg/Position3D";
}

template<>
struct has_fixed_size<etsi_its_mapem_ts_msgs::msg::Position3D>
  : std::integral_constant<bool, has_fixed_size<etsi_its_mapem_ts_msgs::msg::Elevation>::value && has_fixed_size<etsi_its_mapem_ts_msgs::msg::Latitude>::value && has_fixed_size<etsi_its_mapem_ts_msgs::msg::Longitude>::value> {};

template<>
struct has_bounded_size<etsi_its_mapem_ts_msgs::msg::Position3D>
  : std::integral_constant<bool, has_bounded_size<etsi_its_mapem_ts_msgs::msg::Elevation>::value && has_bounded_size<etsi_its_mapem_ts_msgs::msg::Latitude>::value && has_bounded_size<etsi_its_mapem_ts_msgs::msg::Longitude>::value> {};

template<>
struct is_message<etsi_its_mapem_ts_msgs::msg::Position3D>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__POSITION3_D__TRAITS_HPP_
